#include "keylook.hpp"

static char title1[]="Message        Key Char Repeat Scan Ext ALT Prev Tran";
static char title2[]="-------        --- ---- ------ ---- --- --- ---- ----";
static char *fmt[2] = { "%-14s %3d    %c %6u %4d %3s %3s %4s %4s\n",
						"%-14s    %3d %c %6u %4d %3s %3s %4s %4s\n" };

keylook::keylook(Window *w):QuickText(w) {
	moveTo(0,24);
	header=new TextPane(this);
	header->create(Dimension(600,40));
	header->printf("%s\n%s",title1,title2);
	setHandler(this,(NotifyProc)keylook::keyUp,WM_KEYUP);
	setHandler(this,(NotifyProc)keylook::keyUp,WM_SYSKEYUP);
	setHandler(this,(NotifyProc)keylook::keyDown,WM_KEYDOWN);
	setHandler(this,(NotifyProc)keylook::keyDown,WM_SYSKEYDOWN);
	setFocus();
}

keylook::~keylook() {
	delete header;
}

int keylook::Char(KeyEvt*Ev) {
	return showKey("Char",Ev,1);
}

int keylook::keyUp(KeyEvt*Ev) {
	return showKey("Up",Ev);
}

int keylook::keyDown(KeyEvt*Ev) {
	return showKey("Down",Ev);
}

int keylook::showKey(char *s,KeyEvt *Ev,int i) {
	printf(fmt[i],s,
		(int)Ev->ch(),
		(i) ? Ev->ch():' ',
		Ev->repeat(),
		Ev->code(),
		(Ev->extended()) ? "Yes"  : "No",
		(Ev->alt())   ? "Yes"  : "No",
		(Ev->prevState()) ? "Down" : "Up",
		(Ev->tranState()) ? "Up"   : "Down");
	return 1;
}

MainFrame::MainFrame() : AppFrame("zApp Keyboard Looker") {
	create();
	k=new keylook(this);	
}

int MainFrame::activate(ActivateEvt *e) {
	if (k)
		if (e->active())
			k->setFocus();
	return 1;
}

void App::main() {
	MainFrame *frame=new MainFrame();
	app->go();
	delete frame;
}
